(*
    ===========================================================================

    ---------------------------------------------------------------------------
    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------
    Using Hooks
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/usinghooks.htm


    ---------------------------------------------------------------------------
    2003/11/25  n

    ===========================================================================
*)


unit HookMain;

interface

uses
    Windows, iFMO, iHookTypes;

(*
    ===========================================================================
    export
    ===========================================================================
*)

//  tbNCXg[
function    HookInstall(Wnd: HWND; HookType: THookType): Boolean; export; stdcall;

//  tbNACXg[
procedure   HookUnInstall(HookType: THookType); export; stdcall;

//  SACXg[
procedure   HookUnInstallFull(); export; stdcall;

implementation

(*
    ===========================================================================
    type
    ===========================================================================
*)

//  L̓eɂ\
//  ɂ̏LĂȂƌĂяovOANeBułȂ
//  bZ[WłȂBtbNvOƂĒvI!!
//  łADLLgp镡̃vO𗧂グƁAŌɋNv
//  ÕEBhEnhŏ㏑Ă܂āANĂvO
//  ̐tbNbZ[WĂBł낤B
//  łAC++BuildertWinSight322dNh~Ă邱ƂƂ
//  悤B
type
    PShareHookInfo = ^TShareHookInfo;
    TShareHookInfo = packed record
        HostWindow: HWND;                           //  ʒmEBhE
        HookHandle: array[THookType] of  HHOOK;     //  tbÑnh
    end;


//  tbN֐^
type
    THookProc = function(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

//  LłȂeɂ\(Ȃ͕׋s)
type
    PLocalHookInfo = ^TLocalHookInfo;
    TLocalHookInfo = record
        Hooked   : Boolean;     //  tbNtO
        HookType : integer;     //  tbN̎
        HookProc : THookProc;   //  tbN֐
        FmoHandle: THandle;     //  FMOnh
        FmoName  : ShortString; //  FMOʖ
    end;

(*
    ===========================================================================
    var
    ===========================================================================
*)
//  tbN֐̃CXg[Ɋւێz
var
    LocalHookInfo: array[THookType] of TLocalHookInfo;

(******************************************************************************)

(*
    ===========================================================================
    CallWndProc
    ===========================================================================
*)
function    CallWndProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htCallWndProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_CallWndProc_HC_ACTION, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    CallWndRetProc
    ===========================================================================
*)
function    CallWndRetProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htCallWndProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_CallWndRetProc_HC_ACTION, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    CBTProc
    ===========================================================================
*)
function    CBTProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htCBTProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HCBT_ACTIVATE:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_ACTIVATE, wParam, lParam);
        HCBT_CLICKSKIPPED:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_CLICKSKIPPED, wParam, lParam);
        HCBT_CREATEWND:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_CREATEWND, wParam, lParam);
        HCBT_DESTROYWND:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_DESTROYWND, wParam, lParam);
        HCBT_KEYSKIPPED:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_KEYSKIPPED, wParam, lParam);
        HCBT_MINMAX:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_MINMAX, wParam, lParam);
        HCBT_MOVESIZE:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_MOVESIZE, wParam, lParam);
        HCBT_QS:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_QS, wParam, lParam);
        HCBT_SETFOCUS:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_SETFOCUS, wParam, lParam);
        HCBT_SYSCOMMAND:
            PostMessage(Shi^.HostWindow, UM_CBTProc_HCBT_SYSCOMMAND, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    DebugProc
    ===========================================================================
*)
function    DebugProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htDebugProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_DebugProc_HC_ACTION, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    ForegroundIdleProc
    ===========================================================================
*)
function    ForegroundIdleProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htForegroundIdleProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_ForegroundIdleProc_HC_ACTION, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    GetMsgProc
    ===========================================================================
*)
function    GetMsgProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htGetMsgProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_GetMsgProc_HC_ACTION, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    JournalPlaybackProc
    ===========================================================================
*)
function    JournalPlaybackProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htJournalPlaybackProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_GETNEXT:
            PostMessage(Shi^.HostWindow, UM_JournalPlaybackProc_HC_GETNEXT, wParam, lParam);
        HC_NOREMOVE:
            PostMessage(Shi^.HostWindow, UM_JournalPlaybackProc_HC_NOREMOVE, wParam, lParam);
        HC_SKIP:
            PostMessage(Shi^.HostWindow, UM_JournalPlaybackProc_HC_SKIP, wParam, lParam);
        HC_SYSMODALOFF:
            PostMessage(Shi^.HostWindow, UM_JournalPlaybackProc_HC_SYSMODALOFF, wParam, lParam);
        HC_SYSMODALON:
            PostMessage(Shi^.HostWindow, UM_JournalPlaybackProc_HC_SYSMODALON, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    JournalRecordProc
    ===========================================================================
*)
function    JournalRecordProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htJournalRecordProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_JournalRecordProc_HC_ACTION, wParam, lParam);
        HC_SYSMODALOFF:
            PostMessage(Shi^.HostWindow, UM_JournalRecordProc_HC_SYSMODALOFF, wParam, lParam);
        HC_SYSMODALON:
            PostMessage(Shi^.HostWindow, UM_JournalRecordProc_HC_SYSMODALON, wParam, lParam);
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    KeyboardProc
    ===========================================================================
*)
function    KeyboardProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htKeyboardProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_KeyboardProc_HC_ACTION, wParam, lParam);

        HC_NOREMOVE:
            PostMessage(Shi^.HostWindow, UM_KeyboardProc_HC_NOREMOVE, wParam, lParam);

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    LowLevelKeyboardProc
    ===========================================================================
*)
(*
function    LowLevelKeyboardProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htLowLevelKeyboardProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_LowLevelKeyboardProc_HC_ACTION, wParam, lParam);

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;
*)

(*
    ===========================================================================
    MouseProc
    ===========================================================================
*)
function    MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htMouseProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_MouseProc_HC_ACTION, wParam, lParam);

        HC_NOREMOVE:
            PostMessage(Shi^.HostWindow, UM_MouseProc_HC_NOREMOVE, wParam, lParam);

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    LowLevelMouseProc
    ===========================================================================
*)
(*
function    LowLevelMouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htLowLevelMouseProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HC_ACTION:
            PostMessage(Shi^.HostWindow, UM_LowLevelMouseProc_HC_ACTION, wParam, lParam);

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;
*)

(*
    ===========================================================================
    MessageProc
    ===========================================================================
*)
function    MessageProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htMessageProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of
{
        MSGF_DDEMGR:
            PostMessage(Shi^.HostWindow, UM_MessageProc_MSGF_DDEMGR, wParam, lParam);
}
        MSGF_DIALOGBOX:
            PostMessage(Shi^.HostWindow, UM_MessageProc_MSGF_DIALOGBOX, wParam, lParam);

        MSGF_MENU:
            PostMessage(Shi^.HostWindow, UM_MessageProc_MSGF_MENU, wParam, lParam);

        MSGF_SCROLLBAR:
            PostMessage(Shi^.HostWindow, UM_MessageProc_MSGF_SCROLLBAR, wParam, lParam);

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    SysMsgProc
    ===========================================================================
*)
function    ShellProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htShellProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        HSHELL_ACCESSIBILITYSTATE:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_ACCESSIBILITYSTATE, wParam, lParam);
        HSHELL_ACTIVATESHELLWINDOW:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_ACTIVATESHELLWINDOW, wParam, lParam);
{
        HSHELL_APPCOMMAND:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_APPCOMMAND, wParam, lParam);
}
        HSHELL_GETMINRECT:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_GETMINRECT, wParam, lParam);
        HSHELL_LANGUAGE:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_LANGUAGE, wParam, lParam);
        HSHELL_REDRAW:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_REDRAW, wParam, lParam);
        HSHELL_TASKMAN:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_TASKMAN, wParam, lParam);
        HSHELL_WINDOWACTIVATED:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_WINDOWACTIVATED, wParam, lParam);
        HSHELL_WINDOWCREATED:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_WINDOWCREATED, wParam, lParam);
        HSHELL_WINDOWDESTROYED:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_WINDOWDESTROYED, wParam, lParam);
{
        HSHELL_WINDOWREPLACED:
            PostMessage(Shi^.HostWindow, UM_ShellProc_HSHELL_WINDOWREPLACED, wParam, lParam);
}
        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    SysMsgProc
    ===========================================================================
*)
function    SysMsgProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
const
    HOOK_TYPE: THookType = htSysMsgProc;
var
    hFMO: THandle;
    p   : Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HOOK_TYPE];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        MSGF_DIALOGBOX:
            PostMessage(Shi^.HostWindow, UM_SysMsgProc_MSGF_DIALOGBOX, wParam, lParam);

        MSGF_MENU:
            PostMessage(Shi^.HostWindow, UM_SysMsgProc_MSGF_MENU, wParam, lParam);

        MSGF_SCROLLBAR:
            PostMessage(Shi^.HostWindow, UM_SysMsgProc_MSGF_SCROLLBAR, wParam, lParam);

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle[HOOK_TYPE], nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(******************************************************************************)

(*
    ===========================================================================
    tbNCXg[
    ===========================================================================
*)
function    HookInstall(Wnd: HWND; HookType: THookType): Boolean;
var
    hFMO: THandle;
    p: Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HookType];
    GetFileMappingObject(hFMO, p, Lhi^.FmoName);

    //  tbN\̏(邢͎擾)
    Shi := PShareHookInfo(p);

    try
        //  Ƒ҂āBłɒNtbNĂ肵Ă˂낤ȁB
        //  DLL͓1̃AvP[V炵Ăׂ܂B
        if (Shi^.HostWindow <> 0) and (Shi^.HostWindow <> Wnd) then
        begin
            RaiseAlwaysCreatedByOtherWindowMMF(Shi^.HostWindow);
        end;

        //  ʒmL^
        Shi^.HostWindow := Wnd;

        //  tbN֐̓o^
        Shi^.HookHandle[HookType] := SetWindowsHookEx(Lhi^.HookType, Lhi^.HookProc, HInstance, 0);

        //  tbN
        Lhi^.Hooked := (Shi^.HookHandle[HookType] > 0);

        //  ߂l
        Result := Lhi^.Hooked;

    finally
        //  MMFgpI
        ReleaseFileMappingObject(hFMO, p);
    end;
end;

(*
    ===========================================================================
    tbNACXg[
    ===========================================================================
*)
procedure   HookUnInstall(HookType: THookType);
var
    hFMO: THandle;
    p: Pointer;
    Lhi: PLocalHookInfo;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    Lhi := @LocalHookInfo[HookType];
    GetFileMappingObject(hFMO, p, Lhi.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //tbN
    if Lhi^.Hooked then
    begin
        UnhookWindowsHookEx(Shi^.HookHandle[HookType]);
    end;

    //  MMFgpI
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    tbNSACXg[
    ---------------------------------------------------------------------------
    ȂƂĂ̂H
    ===========================================================================
*)
procedure   HookUnInstallFull();
var
    i: THookType;
begin
    //  
    for i := Low(THookType) to High(THookType) do
    begin
        HookUnInstall(i);
    end;
end;

(******************************************************************************)

(*
    ===========================================================================
    tbN^CvƂ̏z񏉊
    ===========================================================================
*)
procedure   InitLocalHookInfo();
var
    i: THookType;
begin
    //  
    for i := Low(THookType) to High(THookType) do
    begin
        LocalHookInfo[i].Hooked := false;
        LocalHookInfo[i].HookType := HookTypeFlag[i];
        LocalHookInfo[i].HookProc := nil;
        LocalHookInfo[i].FmoHandle := 0;
        LocalHookInfo[i].FmoName := HookTypeStr[i];
    end;

    //  tbN֐o^
    LocalHookInfo[htCallWndProc].HookProc       := CallWndProc;
    LocalHookInfo[htCallWndRetProc].HookProc    := CallWndRetProc;
    LocalHookInfo[htCBTProc].HookProc           := CBTProc;
    LocalHookInfo[htDebugProc].HookProc         := DebugProc;
    LocalHookInfo[htForegroundIdleProc].HookProc := ForegroundIdleProc;
    LocalHookInfo[htGetMsgProc].HookProc        := GetMsgProc;
    LocalHookInfo[htJournalPlaybackProc].HookProc := JournalPlaybackProc;
    LocalHookInfo[htJournalRecordProc].HookProc := JournalRecordProc;
    LocalHookInfo[htKeyboardProc].HookProc      := KeyboardProc;
//    LocalHookInfo[htLowLevelKeyboardProc].HookProc := LowLevelKeyboardProc;
    LocalHookInfo[htMouseProc].HookProc         := MouseProc;
//    LocalHookInfo[htLowLevelMouseProc].HookProc := LowLevelMouseProc;
    LocalHookInfo[htMessageProc].HookProc       := MessageProc;
    LocalHookInfo[htShellProc].HookProc         := ShellProc;
    LocalHookInfo[htSysMsgProc].HookProc        := SysMsgProc;
end;

(*
    ===========================================================================
    MMF ꊇ쐬
    ===========================================================================
*)
procedure   CreateFileMappingObjects();
var
    i: THookType;
    Lhi: PLocalHookInfo;
    Size: integer;
begin
    Size := SizeOf(TShareHookInfo);
    for i := Low(THookType) to High(THookType) do
    begin
        try
            Lhi := @LocalHookInfo[i];
            Lhi^.FmoHandle := CreateFileMappingObject(Size, Lhi^.FmoName);
        except
            ;   //  Ԃ
        end;
    end;
end;

(*
    ===========================================================================
    MMF ꊇ
    ===========================================================================
*)
procedure   DestroyFileMappingObjects();
var
    i: THookType;
begin
    for i := Low(THookType) to High(THookType) do
    begin
        DestroyFileMappingObject(LocalHookInfo[i].FmoHandle);
    end;
end;

(*
    ===========================================================================
    initialization
    ===========================================================================
*)
initialization
begin
    InitLocalHookInfo();
    CreateFileMappingObjects();
end;

(*
    ===========================================================================
    finalization
    ===========================================================================
*)
finalization
begin
    HookUnInstallFull();
    DestroyFileMappingObjects();
end;

end.

