unit iHookTypes;

interface

uses
    Windows, Messages;

(*
    ===========================================================================
    type
    ===========================================================================
*)
type
    //  tbN^CvɑΉ񋓌^
    THookType =
    (
        htCallWndProc
        ,htCallWndRetProc
        ,htCBTProc
        ,htDebugProc
        ,htForegroundIdleProc
        ,htGetMsgProc
        ,htJournalPlaybackProc
        ,htJournalRecordProc
        ,htKeyboardProc
//      ,htLowLevelKeyboardProc
        ,htMouseProc
//      ,htLowLevelMouseProc
        ,htMessageProc
        ,htShellProc
        ,htSysMsgProc
    );

(*
    ===========================================================================
    const
    ===========================================================================
*)
const
    //  낢ƎgĂ݂悤pGUID
    HOOK_GUID = '{95BFD938-9379-4EDB-BB84-7F8DF79E186F}';

const
    //  tbN^CvɑΉ镶
    HookTypeStr: array[THookType] of ShortString =
    (
        'htCallWndProc'
        ,'htCallWndRetProc'
        ,'htCBTProc'
        ,'htDebugProc'
        ,'htForegroundIdleProc'
        ,'htGetMsgProc'
        ,'htJournalPlaybackProc'
        ,'htJournalRecordProc'
        ,'htKeyboardProc'
//      ,'htLowLevelKeyboardProc'
        ,'htMouseProc'
//      ,'htLowLevelMouseProc'
        ,'htMessageProc'
        ,'htShellProc'
        ,'htSysMsgProc'
    );

const
    //  tbN^CvɑΉWH_tO
    HookTypeFlag: array[THookType] of integer =
    (
        WH_CALLWNDPROC
        , WH_CALLWNDPROCRET
        , WH_CBT
        , WH_DEBUG
        , WH_FOREGROUNDIDLE
        , WH_GETMESSAGE
        , WH_JOURNALPLAYBACK
        , WH_JOURNALRECORD
        , WH_KEYBOARD
//        , WH_KEYBOARD_LL
        , WH_MOUSE
//        , WH_MOUSE_LL
        , WH_MSGFILTER
        , WH_SHELL
        , WH_SYSMSGFILTER
    );
    
const
    //  ʒmpEBhEbZ[W
    //  RegisterWindowMessageׂז

    //  O̒萔l̎gp1ӏɗ}...ł悯₱
    UM_HOOKPROC_START = WM_APP + 100;

    //  CallWndProc
    UM_CallWndProc_BEGIN            = UM_HOOKPROC_START;
    UM_CallWndProc_HC_ACTION        = UM_CallWndProc_BEGIN + 0;
    UM_CallWndProc_END              = UM_CallWndProc_BEGIN + 0;  

    //  CallWndRetProc
    UM_CallWndRetProc_BEGIN         = UM_CallWndProc_END + 1;
    UM_CallWndRetProc_HC_ACTION     = UM_CallWndRetProc_BEGIN + 0;
    UM_CallWndRetProc_END           = UM_CallWndRetProc_BEGIN + 0;

    //  CBTProc
    UM_CBTProc_BEGIN                = UM_CallWndRetProc_END + 1;
    UM_CBTProc_HCBT_ACTIVATE        = UM_CBTProc_BEGIN + 0;
    UM_CBTProc_HCBT_CLICKSKIPPED    = UM_CBTProc_BEGIN + 1;
    UM_CBTProc_HCBT_CREATEWND       = UM_CBTProc_BEGIN + 2;
    UM_CBTProc_HCBT_DESTROYWND      = UM_CBTProc_BEGIN + 3;
    UM_CBTProc_HCBT_KEYSKIPPED      = UM_CBTProc_BEGIN + 4;
    UM_CBTProc_HCBT_MINMAX          = UM_CBTProc_BEGIN + 5;
    UM_CBTProc_HCBT_MOVESIZE        = UM_CBTProc_BEGIN + 6;
    UM_CBTProc_HCBT_QS              = UM_CBTProc_BEGIN + 7;
    UM_CBTProc_HCBT_SETFOCUS        = UM_CBTProc_BEGIN + 8;
    UM_CBTProc_HCBT_SYSCOMMAND      = UM_CBTProc_BEGIN + 9;
    UM_CBTProc_END                  = UM_CBTProc_BEGIN + 9;

    //  DebugProc
    UM_DebugProc_BEGIN              = UM_CBTProc_END + 1;
    UM_DebugProc_HC_ACTION          = UM_DebugProc_BEGIN + 0;
    UM_DebugProc_END                = UM_DebugProc_BEGIN + 0;

    //  ForegroundIdleProc
    UM_ForegroundIdleProc_BEGIN     = UM_DebugProc_END + 1;
    UM_ForegroundIdleProc_HC_ACTION = UM_ForegroundIdleProc_BEGIN + 0;
    UM_ForegroundIdleProc_END       = UM_ForegroundIdleProc_BEGIN + 0;

    //  GetMsgProc
    UM_GetMsgProc_BEGIN             = UM_ForegroundIdleProc_END + 1;
    UM_GetMsgProc_HC_ACTION         = UM_GetMsgProc_BEGIN + 0;
    UM_GetMsgProc_END               = UM_GetMsgProc_BEGIN + 0;

    //  JournalPlaybackProc
    UM_JournalPlaybackProc_BEGIN          = UM_GetMsgProc_END + 1;
    UM_JournalPlaybackProc_HC_GETNEXT     = UM_JournalPlaybackProc_BEGIN + 0;
    UM_JournalPlaybackProc_HC_NOREMOVE    = UM_JournalPlaybackProc_BEGIN + 1;
    UM_JournalPlaybackProc_HC_SKIP        = UM_JournalPlaybackProc_BEGIN + 2;
    UM_JournalPlaybackProc_HC_SYSMODALOFF = UM_JournalPlaybackProc_BEGIN + 3;
    UM_JournalPlaybackProc_HC_SYSMODALON  = UM_JournalPlaybackProc_BEGIN + 4;
    UM_JournalPlaybackProc_END            = UM_JournalPlaybackProc_BEGIN + 4;

    //  UM_JournalRecordProc
    UM_JournalRecordProc_BEGIN          = UM_JournalPlaybackProc_END + 1;
    UM_JournalRecordProc_HC_ACTION      = UM_JournalRecordProc_BEGIN + 0;
    UM_JournalRecordProc_HC_SYSMODALOFF = UM_JournalRecordProc_BEGIN + 1;
    UM_JournalRecordProc_HC_SYSMODALON  = UM_JournalRecordProc_BEGIN + 2;
    UM_JournalRecordProc_END            = UM_JournalRecordProc_BEGIN + 2;

    //  KeyboardProc
    UM_KeyboardProc_BEGIN       = UM_JournalRecordProc_END + 1;
    UM_KeyboardProc_HC_ACTION   = UM_KeyboardProc_BEGIN + 0;
    UM_KeyboardProc_HC_NOREMOVE = UM_KeyboardProc_BEGIN + 1;
    UM_KeyboardProc_END         = UM_KeyboardProc_BEGIN + 1;

    //  LowLevelKeyboardProc
    UM_LowLevelKeyboardProc_BEGIN       = UM_KeyboardProc_END + 1;
    UM_LowLevelKeyboardProc_HC_ACTION   = UM_LowLevelKeyboardProc_BEGIN + 0;
    UM_LowLevelKeyboardProc_END         = UM_LowLevelKeyboardProc_BEGIN + 0;

    //  MouseProc
    UM_MouseProc_BEGIN          = UM_LowLevelKeyboardProc_END + 1;
    UM_MouseProc_HC_ACTION      = UM_MouseProc_BEGIN + 0;
    UM_MouseProc_HC_NOREMOVE    = UM_MouseProc_BEGIN + 1;
    UM_MouseProc_END            = UM_MouseProc_BEGIN + 1;

    //  LowLevelMouseProc
    UM_LowLevelMouseProc_BEGIN      = UM_MouseProc_END + 1;
    UM_LowLevelMouseProc_HC_ACTION  = UM_LowLevelMouseProc_BEGIN + 0;
    UM_LowLevelMouseProc_END        = UM_LowLevelMouseProc_BEGIN + 0;

    //  MessageProc
    UM_MessageProc_BEGIN            = UM_LowLevelMouseProc_END + 1;
    UM_MessageProc_MSGF_DDEMGR      = UM_MessageProc_BEGIN + 0;
    UM_MessageProc_MSGF_DIALOGBOX   = UM_MessageProc_BEGIN + 1;
    UM_MessageProc_MSGF_MENU        = UM_MessageProc_BEGIN + 2;
    UM_MessageProc_MSGF_SCROLLBAR   = UM_MessageProc_BEGIN + 3;
    UM_MessageProc_END              = UM_MessageProc_BEGIN + 3;

    //  ShellProc
    UM_ShellProc_BEGIN                      = UM_MessageProc_END + 1;
    UM_ShellProc_HSHELL_ACCESSIBILITYSTATE  = UM_ShellProc_BEGIN + 0;
    UM_ShellProc_HSHELL_ACTIVATESHELLWINDOW = UM_ShellProc_BEGIN + 1;
    UM_ShellProc_HSHELL_APPCOMMAND          = UM_ShellProc_BEGIN + 2;
    UM_ShellProc_HSHELL_GETMINRECT          = UM_ShellProc_BEGIN + 3;
    UM_ShellProc_HSHELL_LANGUAGE            = UM_ShellProc_BEGIN + 4;
    UM_ShellProc_HSHELL_REDRAW              = UM_ShellProc_BEGIN + 5;
    UM_ShellProc_HSHELL_TASKMAN             = UM_ShellProc_BEGIN + 6;
    UM_ShellProc_HSHELL_WINDOWACTIVATED     = UM_ShellProc_BEGIN + 7;
    UM_ShellProc_HSHELL_WINDOWCREATED       = UM_ShellProc_BEGIN + 8;
    UM_ShellProc_HSHELL_WINDOWDESTROYED     = UM_ShellProc_BEGIN + 9;
    UM_ShellProc_HSHELL_WINDOWREPLACED      = UM_ShellProc_BEGIN + 10;
    UM_ShellProc_END                        = UM_ShellProc_BEGIN + 10;

    //  SysMsgProc
    UM_SysMsgProc_BEGIN             = UM_ShellProc_END + 1;
    UM_SysMsgProc_MSGF_DIALOGBOX    = UM_SysMsgProc_BEGIN + 0;
    UM_SysMsgProc_MSGF_MENU         = UM_SysMsgProc_BEGIN + 1;
    UM_SysMsgProc_MSGF_SCROLLBAR    = UM_SysMsgProc_BEGIN + 2;
    UM_SysMsgProc_END               = UM_SysMsgProc_BEGIN + 2;

const
    //  DLL
    HOOK_DLL_NAME = 'hook.dll';

implementation

end.

